import numpy as np
import matplotlib.pyplot as plt
import glob
from mpl_toolkits.basemap import Basemap
import matplotlib as mpl
import pyresample as pr

#plt.style.use('ds_style2')

#####################################################
saveFig = False

whattoplot ='fcc'
basepath = '/home/dstrack/WBH/acloud/iasi/results/fcc/gesamt/'
basepath = '/net/kumbang/dstrack/validate/fcc/big/'

# whattoplot ='ctp'
# # basepath = '/home/dstrack/WBH/acloud/iasi/results/ctp/gesamt/'
# basepath = '/net/kumbang/dstrack/validate/ctp/big/'
savepath = './'

periods = [[20170523, 20170529],
           [20170530, 20170612],
           [20170613, 20170626]]


whatmaptype = 'big'

if whatmaptype == 'big':
    west = -30.0
    ost = 70.0
    nord = 90.0
    sued = 60.0

    step_westost = 2
    step_nordsued = 2
elif whatmaptype == 'small':
    west = 0.0
    ost = 20.0
    nord = 82.0
    sued = 76.0

    step_westost = 1
    step_nordsued = 1


marksmallarea = True
#############################################################
if whattoplot == 'fcc':

    valfiles = sort(glob.glob(basepath + 'fractional_cloud_cover_2017*.txt'))
    latfiles = sort(glob.glob(basepath + 'latitudes_2017*.txt'))
    lonfiles = sort(glob.glob(basepath + 'longitudes_2017*.txt'))

    for period in periods:
        indices = []
        for i, elem in enumerate(valfiles):
            date = int(elem[-14:-10])*10**4 + int(elem[-9:-7])*10**2 + int(elem[-6:-4])
            if date >= period[0] and date <= period[1]:
                indices.append(i)

    # valfile = valfiles[-1]
    # latfile = latfiles[-1]
    # lonfile = lonfiles[-1]
        vals = []
        lats = []
        lons = []

        for index in indices:

            vals.append(np.loadtxt(valfiles[index]))
            lats.append(np.loadtxt(latfiles[index]))
            lons.append(np.loadtxt(lonfiles[index]))

        vals = np.concatenate(vals)
        lats = np.concatenate(lats)
        lons = np.concatenate(lons)


        # invalid data should not been taking into acount when calculating the mean. An invalid entry therefore counts as zero
        # while a valid one counts as one
        countweight = np.copy(vals)
        countweight[~np.isnan(countweight)] = 1
        countweight[np.isnan(countweight)] = 0

        vals[np.isnan(vals)] = 0

        # create two histograms with 2x2 degree bins. One with the sum of all pressure values within that bin
        # one with a count of all valid pressure values within a bin
        lentotal = np.size(vals)
        zi, yi, xi = np.histogram2d(lons.reshape(lentotal),
                                    lats.reshape(lentotal),
                                    bins=(int((np.abs(ost)+np.abs(west))/step_westost),
                                          int((nord-sued)/step_nordsued)),
                                    range = [[west, ost],[sued, nord]],
                                    weights=vals.reshape(lentotal), normed=False)
        counts, _, _ = np.histogram2d(lons.reshape(lentotal),
                                      lats.reshape(lentotal),
                                      bins=(int((np.abs(ost) + np.abs(west)) / step_westost),
                                            int((nord - sued) / step_nordsued)),
                                      range=[[west, ost], [sued, nord]],
                                      weights=countweight.reshape(lentotal), normed=False)

        # sum devided by n gives mean
        zi = zi / counts

        if whatmaptype == 'big':
            scalefactor = 0.8
            fig = plt.figure(figsize=(scalefactor * 11.69, scalefactor * 8.27))

            projection = "+proj=stere +lat_0=79 +lat_ts=70 +lon_0=8 +k=1 +x_0=0 +y_0=0 +a=6378273 +b=6356889.449 +units=m"
            grid = 3.125
            ar = [i*1000 for i in [-500, -500, 500, 500]]
            xpoints = int((ar[2]-ar[0])/grid)/1000
            ypoints = int((ar[3]-ar[1])/grid)/1000
            area = pr.utils.get_area_def("nsidc_n","nsidc grid northern hemisphere", "nsidc_grid", projection, xpoints, ypoints, ar)
            lon, lat = area.get_lonlats()
            lbls_mer = [0,0,0,1]
            lbls_par = [1,0,1,0]
            cbar_pad = 0.15

            map = Basemap(lon[-1,0], lat[-1,0], lon[0,-1], lat[0,-1], projection='stere', lat_0=79, lon_0=8,lat_ts=70, resolution='h')
            # map = Basemap(projection='npstere', boundinglat=60, lon_0=20, resolution='h')
            map.drawcoastlines(linewidth=0.2) 
           # map.fillcontinents()
            map.drawmeridians(np.arange(-180.,181.,5.), labels=lbls_mer, linewidth=0.3, latmax=90,fontsize=12)
            map.drawparallels(np.arange(-80.,91.,2.), labels=lbls_par, linewidth=0.3, latmax=90,fontsize=12)

#            yig, xig = np.meshgrid(yi, xi)
            xim = (xi[1::]+xi[:-1])/2.
            yim = (yi[1::]+yi[:-1])/2.

            yig, xig = np.meshgrid(yim, xim)
            X, Y = map(yig, xig)
              # #   map.contourf(X,Y,vpall)
              # map.scatter(X, Y, c=pressure_all, vmin=200.0, vmax=1000.0, s=5, cmap=plt.cm.jet) # extend='both')
              # map.scatter(X, Y, c=zi.T, vmin=200.0, vmax=1000.0, s=5, cmap=plt.cm.jet)  # extend='both')
#             map.contourf(X,Y,zi.T, levels=np.linspace(0,100,21).tolist(), cmap=plt.cm.jet)
            map.pcolor(X, Y, np.ma.masked_invalid(zi.T), vmin=0.0, vmax=100.0, cmap=plt.cm.jet)
            # norm = mpl.colors.Normalize(vmin=0, vmax=100)
            # cb1 = mpl.colorbar.ColorbarBase(norm=norm)
            # cb1.set_label(u'fractional cloud cover [%]')
#            plt.title('fcc between {} and {}'. format(period[0], period[1]))

            if marksmallarea:

                xkern = []
                ykern = []
                for i in np.arange(200):
                    xkern.append(i/10.)
                    ykern.append(76)
                for i in np.arange(199, -1, -1):
                    xkern.append(i/10.)
                    ykern.append(82)
                xkern.append(0)
                ykern.append(76)

                map.plot(xkern, ykern, latlon=True, color='black', linewidth=2)


            # axisbounds = plt.axis()
            # plt.axis([axisbounds[0], axisbounds[1], axisbounds[2], axisbounds[3] * 0.5])

            # plt.axis([axisbounds[0], axisbounds[1], axisbounds[2], axisbounds[3] * 0.5])
            # plt.tight_layout(rect=[0.05, 0, 1, 1])

            if saveFig:
                if marksmallarea:
                    plt.savefig(savepath + 'plots/map/fcc_map_marksmall_period_{}-{}.eps'.format(period[0], period[1]))
                else:
                    plt.savefig(savepath + 'plots/map/fcc_map_period_{}-{}.eps'.format(period[0], period[1]))
                plt.close()
            else:
                plt.show()
            print 'period {}-{} is done'.format(period[0], period[1])

################## ctp ###############################
elif whattoplot == 'ctp':

    valfiles = sort(glob.glob(basepath + 'cloud_top_pressure_2017*.txt'))
    latfiles = sort(glob.glob(basepath + 'latitudes_2017*.txt'))
    lonfiles = sort(glob.glob(basepath + 'longitudes_2017*.txt'))
    # import pdb;pdb.set_trace()

    for period in periods:
        indices = []
        for i, elem in enumerate(valfiles):
            date = int(elem[-14:-10])*10**4 + int(elem[-9:-7])*10**2 + int(elem[-6:-4])
            if date >= period[0] and date <= period[1]:
                indices.append(i)

    # valfile = valfiles[-1]
    # latfile = latfiles[-1]
    # lonfile = lonfiles[-1]
        vals = []
        lats = []
        lons = []

        for index in indices:

            vals.append(np.loadtxt(valfiles[index]))
            lats.append(np.loadtxt(latfiles[index]))
            lons.append(np.loadtxt(lonfiles[index]))

        vals = np.concatenate(vals)
        lats = np.concatenate(lats)
        lons = np.concatenate(lons)


        # invalid data should not been taking into acount when calculating the mean. An invalid entry therefore counts as zero
        # while a valid one counts as one
        countweight = np.copy(vals)
        countweight[~np.isnan(countweight)] = 1
        countweight[np.isnan(countweight)] = 0

        vals[np.isnan(vals)] = 0
        vals = vals*0.01  # Pa -> hP

        # create two histograms with 2x2 degree bins. One with the sum of all pressure values within that bin
        # one with a count of all valid pressure values within a bin
        lentotal = np.size(vals)
        zi, yi, xi = np.histogram2d(lons.reshape(lentotal),
                                    lats.reshape(lentotal),
                                    bins=(int((np.abs(ost)+np.abs(west))/step_westost),
                                          int((nord-sued)/step_nordsued)),
                                    range = [[west, ost],[sued, nord]],
                                    weights=vals.reshape(lentotal), normed=False)
        counts, _, _ = np.histogram2d(lons.reshape(lentotal),
                                      lats.reshape(lentotal),
                                      bins=(int((np.abs(ost) + np.abs(west)) / step_westost),
                                            int((nord - sued) / step_nordsued)),
                                      range=[[west, ost], [sued, nord]],
                                      weights=countweight.reshape(lentotal), normed=False)

        # sum devided by n gives mean
        zi = zi / counts

        if whatmaptype == 'big':
            scalefactor = 0.8
            fig = plt.figure(figsize=(scalefactor * 11.69, scalefactor * 8.27))

            projection = "+proj=stere +lat_0=79 +lat_ts=70 +lon_0=8 +k=1 +x_0=0 +y_0=0 +a=6378273 +b=6356889.449 +units=m"
            grid = 3.125
            ar = [i*1000 for i in [-500, -500, 500, 500]]
            xpoints = int((ar[2]-ar[0])/grid)/1000
            ypoints = int((ar[3]-ar[1])/grid)/1000
            area = pr.utils.get_area_def("nsidc_n","nsidc grid northern hemisphere", "nsidc_grid", projection, xpoints, ypoints, ar)
            lon, lat = area.get_lonlats()
            lbls_mer = [0,0,0,1]
            lbls_par = [1,0,1,0]
            cbar_pad = 0.15

            map = Basemap(lon[-1,0], lat[-1,0], lon[0,-1], lat[0,-1], projection='stere', lat_0=79, lon_0=8,lat_ts=70, resolution='h')
            # map = Basemap(projection='npstere', boundinglat=60, lon_0=20, resolution='h')
            map.drawcoastlines(linewidth=0.2)
            # map.fillcontinents()
            map.drawmeridians(np.arange(-180.,181.,5.), labels=lbls_mer, linewidth=0.3, latmax=90,fontsize=12)
            map.drawparallels(np.arange(-80.,91.,2.), labels=lbls_par, linewidth=0.3, latmax=90,fontsize=12)

#            yig, xig = np.meshgrid(yi, xi)
            xim = (xi[1::]+xi[:-1])/2.
            yim = (yi[1::]+yi[:-1])/2.

            yig, xig = np.meshgrid(yim, xim)
            X, Y = map(yig, xig)

              # #   map.contourf(X,Y,vpall)
              # map.scatter(X, Y, c=pressure_all, vmin=200.0, vmax=1000.0, s=5, cmap=plt.cm.jet) # extend='both')
              # map.scatter(X, Y, c=zi.T, vmin=200.0, vmax=1000.0, s=5, cmap=plt.cm.jet)  # extend='both')
              # map.contourf(X,Y,zi.T, vmin=200.0, vmax=1000.0, cmap=plt.cm.jet, extend='both')
            map.pcolor(X, Y, np.ma.masked_invalid(zi.T), vmin=200.0, vmax=1000.0, cmap=plt.cm.jet)
            # cb1 = map.colorbar()
            # cb1.set_label(u'cloud top pressure [hPa]')
            # plt.title('ctp between {} and {}'. format(period[0], period[1]))

            if marksmallarea:

                xkern = []
                ykern = []
                for i in np.arange(200):
                    xkern.append(i/10.)
                    ykern.append(76)
                for i in np.arange(199, -1, -1):
                    xkern.append(i/10.)
                    ykern.append(82)
                xkern.append(0)
                ykern.append(76)

                map.plot(xkern, ykern, latlon=True, color='black', linewidth=2)

            if saveFig:
                if marksmallarea:
                    plt.savefig(savepath + 'plots/map/ctp_map_marksmall_period_{}-{}.eps'.format(period[0], period[1]))
                else:
                    plt.savefig(savepath + 'plots/map/ctp_map_period_{}-{}.eps'.format(period[0], period[1]))
                plt.close()
            else:
                plt.show()
            print 'period {}-{} is done'.format(period[0], period[1])