
plotonly=1; % 0 = calculate..takes few minutes. 1 = plot only

switch plotonly
    case 0 % also calculate
        
brexit

files=dir('*.txt');

mat_wspeed=NaN.*ones(length(files),1001); % gpm 
mat_wspeed=NaN.*ones(length(files),507); % press

mat_wdir=mat_wspeed;
mat_temp=mat_wdir;

mat_q=mat_temp;
mat_time=mat_q;
for fileid=1:length(files)

    clear indiv_time
    
data=importdata(files(fileid).name);
txt=data.textdata; 
data=data.data;


for kk=1:size(data,1) % extract time now
    dummy=txt{kk+1,2}; 
    year=str2num(dummy(1:4));
    month=str2num(dummy(6:7));
    day=str2num(dummy(9:10));
    hour=str2num(dummy(12:13));
    minute=str2num(dummy(15:16));
    sec=str2num(dummy(18:19)); 
    indiv_time(kk)=datenum(year,month,day,hour,minute,sec); % current sounding
       

end

alti=data(:,3);
gpm=data(:,4); 
lat=data(:,1); 
lon=data(:,2);
press=data(:,6); 
temp_C=data(:,7); % deg C
temp_K=temp_C+273.15;
r_hum=data(:,8); %current sounding 
wdir=data(:,9); 
wspeed=data(:,10); 



u=wspeed.*sind(wdir);
v=wspeed.*cosd(wdir);


%% centered Richardson number averaging

 alti_c=alti+[diff(alti)./2; NaN];
 lat_c=lat+[diff(lat)./2; NaN];
 g=gravity(lat_c,alti_c);
grad_u=[diff(u)./diff(alti);NaN];% m/sec per m
grad_v=[diff(v)./diff(alti);NaN];% m/sec per m
u_c=u+[diff(u)./2;NaN];
v_c=v+[diff(v)./2;NaN];
press_c=press+[diff(press)./2;NaN];


vaporpressure=vpress(temp_K,press,r_hum./100); % hPa
Rd=287;
Rw=461;
cp=1.006*1000;
theta_v=temp_K./(1-vaporpressure.*100.*(1-(Rd/Rw))./(press.*100)).*(1000./press).^(Rd/cp);
theta_v_c=theta_v+[diff(theta_v)./2;NaN];

Ri=g./theta_v_c(1).*(theta_v_c-theta_v_c(1)).*alti_c./(u_c.^2+v_c.^2);
q=hywex(temp_K,press,r_hum./100).*1000; % spec. humidity following Hyland and Wexler
ABL(fileid,1)=alti_c(min(find(Ri>0.25)));
ABL(fileid,2)=press_c(min(find(Ri>0.25)));

%% gpm als vert. Koordinate:
% gridgpm=0:10:1e4;
% 
% rekord=0;
% clear wheregood
% for jj=1:length(gpm)
%     dummy=gpm(jj);
%    
%     if dummy>rekord
%         wheregood(jj)=1;
%         rekord=dummy;
%     else
%         wheregood(jj)=0;
%     end
% end
% wheregood=find(wheregood==1); 
% 
% gpm2=gpm(wheregood); 
% q2=interp1(gpm2,q(wheregood),gridgpm);
% temp2=interp1(gpm2,temp_C(wheregood),gridgpm);
% u2=interp1(gpm2,u(wheregood),gridgpm);
% v2=interp1(gpm2,v(wheregood),gridgpm);
% wdir2=winddir(u2,v2);
% wspeed2=sqrt(u2.^2+v2.^2);
% indiv_time2=interp1(gpm2,indiv_time(wheregood),gridgpm);
% 
% %schreibe jetzt alles in matrizen
% 
% mat_wspeed(fileid,:)=wspeed2;
% mat_wdir(fileid,:)=wdir2;
% mat_temp(fileid,:)=temp2;
% mat_q(fileid,:)=q2;
% mat_time(fileid,:)=indiv_time2;
% starttime(fileid)=indiv_time(1);
% fileid
%%
%% press als vert. koordinate
gridgpm=1020:-2:8;

rekord=1500
clear wheregood
for jj=1:length(press)
    dummy=press(jj);
   
    if dummy<rekord
        wheregood(jj)=1;
        rekord=dummy;
    else
        wheregood(jj)=0;
    end
end
wheregood=find(wheregood==1);

gpm2=press(wheregood);
q2=interp1(gpm2,q(wheregood),gridgpm);
temp2=interp1(gpm2,temp_C(wheregood),gridgpm);
u2=interp1(gpm2,u(wheregood),gridgpm);
v2=interp1(gpm2,v(wheregood),gridgpm);
wdir2=winddir(u2,v2);
wspeed2=sqrt(u2.^2+v2.^2);
indiv_time2=interp1(gpm2,indiv_time(wheregood),gridgpm);



mat_wspeed(fileid,:)=wspeed2;
mat_wdir(fileid,:)=wdir2;
mat_temp(fileid,:)=temp2;
mat_q(fileid,:)=q2;
mat_time(fileid,:)=indiv_time2;
starttime(fileid)=indiv_time(1);
fileid
end
save('ABL_Nya.mat','ABL')

    case 1 % plot only
        brexit
        load('ErlendV3.mat');
                mat_temp=squeeze(mat_temp(1:142,:));
                mat_q=squeeze(mat_q(1:142,:));

    
        [starttime sortind]=sort(starttime);
        mat_q=mat_q(sortind,:);        
   
        xnew=datenum(2017,5,1,12,0,0):1.5:datenum(2017,6,30,12,0,0);
        %ynew=0:100:1e4;
        ynew=1020:-10:8;

        [xnew2 ynew2]=meshgrid(xnew,ynew);
        qnew=interp2(starttime,gridgpm(7:end),mat_q(:,7:end)',xnew2,ynew2);
        
        close all

        
        figure
        plotx=starttime+[diff(starttime/2) 0.5]; % damit pcolor die Bloecke richtig positioniert
        ploty=(gridgpm+[diff(gridgpm/2) -5])./1; % damit pcolor die Bloecke richtig positioniert

        plotx2=[plotx(1)-1 plotx];
        ploty2=[ploty(1)+2/1 ploty];
     mat_temp(:,end+1)=NaN;
     mat_temp(end+1,:)=NaN;
%%
        
        plotx2=[plotx2(1:4), datenum(2017,5,4,22,0,0) plotx2(5:end)];
mat_temp=cat(1,squeeze(mat_temp(1:4,:)),NaN.*ones(1,508),squeeze(mat_temp(5:end,:)));
plotx2(6)=plotx2(6)+0.5;
      
end
%%

%% nun die long time klimatologie aus den homo sonden fuer May/June
%clear all
cd /lidar4/sdahlke/homo_sondes
load('PANGEA_sondes.mat');
% alles auf Mai/Juni squeezen:
q=hywex(T_array+273.15,P_array,RH_array_save./100).*1000; % in g/kg
q=squeeze(q(:,find((LaunchDate_Vector(:,2)==5)|(LaunchDate_Vector(:,2)==6))));
T_array=squeeze(T_array(:,find((LaunchDate_Vector(:,2)==5)|(LaunchDate_Vector(:,2)==6))));
P_array=squeeze(P_array(:,find((LaunchDate_Vector(:,2)==5)|(LaunchDate_Vector(:,2)==6))));
WD_array=squeeze(WD_array(:,find((LaunchDate_Vector(:,2)==5)|(LaunchDate_Vector(:,2)==6))));
WS_array=squeeze(WS_array(:,find((LaunchDate_Vector(:,2)==5)|(LaunchDate_Vector(:,2)==6))));
LaunchDate_Vector=squeeze(LaunchDate_Vector(find((LaunchDate_Vector(:,2)==5)|(LaunchDate_Vector(:,2)==6)),:));

for kk=1:size(LaunchDate_Vector,1)
    
    dummypress=P_array(:,kk);
    dummyq=q(:,kk);
    dummyT=T_array(:,kk);
    dummyWS=WS_array(:,kk);
    dummyWD=WD_array(:,kk);
    
    p_grid=1020:-2:8;
    
   
    rekord=1500;
clear wheregood
for jj=1:length(dummypress)
    dummy=dummypress(jj);
   
    if dummy<rekord
        wheregood(jj)=1;
        rekord=dummy;
    else
        wheregood(jj)=0;
    end
end
wheregood=find(wheregood==1); % fuer den index
dummypress=squeeze(dummypress(wheregood));

    qnew2(:,kk)=interp1(dummypress,dummyq(wheregood),p_grid);
    tnew(:,kk)=interp1(dummypress,dummyT(wheregood),p_grid);
    wdnew(:,kk)=interp1(dummypress,dummyWD(wheregood),p_grid);
    wsnew(:,kk)=interp1(dummypress,dummyWS(wheregood),p_grid);

    

end

startdate=(datenum(2017,5,1,0,0,0));
enddate=(datenum(2017,6,30,0,0,0));

dateloop=datenum(startdate:1:enddate);
cnt=1;
for kk=1:length(dateloop)
    mydate=datevec(dateloop(kk));
    mm=mydate(2);
    dd=mydate(3);
    ind=find((LaunchDate_Vector(:,2)==mm)&(LaunchDate_Vector(:,3)==dd)); % die fertigen indizes fuer jeden tag 
    clim_q(cnt,:)=mynanmean(squeeze(qnew2(:,ind)),2);
    clim_t(cnt,:)=mynanmean(squeeze(tnew(:,ind)),2);
    clim_ws(cnt,:)=mynanmean(squeeze(wsnew(:,ind)),2);
    clim_wd(cnt,:)=mynanmean(squeeze(wdnew(:,ind)),2);

    cnt=cnt+1;
end


%%
load('/lidar4/sdahlke/ACLOUD/ABL_Nya.mat');
ABL=cat(1,[NaN NaN],ABL);
ABL=cat(1,ABL(1:4,:),[NaN NaN],ABL(5:end,:));
close all
figure
set(gcf,'renderer','painters')
  pp=pcolor(plotx2,ploty2,mat_temp');
        set(pp,'edgecolor','none')
  %      clbr=colorbar;
        caxis([-45 10])
        %  colormap(brewermap(22,'YlOrRd'))
colormap(brewermap(22,'*spectral'))
   %     ylabel(clbr,'temperature [^{o}C]','fontsize',18)
        hold on
                   plot(plotx2+[diff(plotx2)/2 0],ABL(:,2)','o','markersize',4)

        xdate=datenum(2017,5,2,12,0,0):7:datenum(2017,6,31,12,0,0);
        xdate2=NaN.*(datenum(2017,5,2,12,0,0):1:datenum(2017,6,31,12,0,0));
        xdate3=(datenum(2017,5,2,12,0,0):1:datenum(2017,6,31,12,0,0));
        xdate2(1:7:end)=xdate(1:1:end);
        for kk=1:length(xdate2)
            if isnan(xdate2(kk))
                xdate_cell{kk}=[];
            else
                            xdate_cell{kk}=datestr(xdate2(kk),'dd/mm');

            end
        end
      
               set(gca,'xtick',xdate3+1,'tickdir','out','xticklabel',xdate_cell,'ylim',[300 1020],'xlim',[datenum(2017,5,24,0,0,0) datenum(2017,6,27,0,0,0)+1.5],'fontsize',16);

hold on
[c, h]=contour(dateloop,p_grid,clim_t',-40:10:10,'black','linewidth',2);
clabel(c,h,'fontsize',12,'labelspacing',300,'rotation',0,'fontweight','bold','color','black')



axis ij
ylabel('pressure [hPa]')
set(findall(gcf,'-property','FontSize'),'FontSize',16)
%print -depsc NyA_temp
%%
close all
  mat_q(:,end+1)=NaN;
     mat_q(end+1,:)=NaN;
    mat_q=cat(1,squeeze(mat_q(1:4,:)),NaN.*ones(1,508),squeeze(mat_q(5:end,:)));

     %%
figure
set(gcf,'renderer','painters')

  pp=pcolor(plotx2,ploty2,mat_q');
        set(pp,'edgecolor','none')
     %   clbr=colorbar;
        caxis([0 6])
          %colormap(brewermap(12,'PuBuGn'))
          blubb=brewermap(12,'*Spectral');
          colormap(blubb)

       % ylabel(clbr,'humidity [g/kg]')
        hold on
                           plot(plotx2+[diff(plotx2)/2 0],ABL(:,2)','o','markersize',4)

        xdate=datenum(2017,5,2,12,0,0):7:datenum(2017,6,31,12,0,0);
        xdate2=datenum(2017,5,2,12,0,0):1:datenum(2017,6,31,12,0,0);

                      set(gca,'xtick',xdate+1,'tickdir','out','xticklabel',datestr(xdate,'dd/mm'),'ylim',[300 1020],'xlim',[datenum(2017,5,23,0,0,0) datenum(2017,6,27,0,0,0)+1.5],'fontsize',16);

hold on
[c, h]=contour(dateloop,p_grid,clim_q',1:3,'black','linewidth',2);
clabel(c,h,'fontsize',12,'labelspacing',250,'rotation',0,'fontweight','bold','color','black')


axis ij
ylabel('pressure [hPa]')
set(findall(gcf,'-property','FontSize'),'FontSize',16)

%print -depsc NyA_hum

