
plotonly = 1;
switch plotonly
    case 0
brexit
plotonly=0;
fl=dir('*.txt');
ndata=numel(fl);
dates=importdata('listofdates.txt');

for kk=1:ndata-1
    data=importdata(fl(kk).name);
    stringdate=dates{kk}(18:37);
    soundingdate(kk)=datenum(str2num(stringdate(2:5)),str2num(stringdate(7:8)),str2num(stringdate(10:11))...
    ,str2num(stringdate(13:14)),str2num(stringdate(16:17)),str2num(stringdate(19:20)));
    

alti=data(:,1);
press=data(:,2);
temp=data(:,3);
temp_K=temp+273.15;
rh=data(:,4);

if size(data,2)>4
wdir=data(:,5);
wspeed=data(:,6);
else
wdir=NaN.*ones(1,size(data,1));
wspeed=NaN.*ones(1,size(data,1));
end


u=wspeed.*sind(wdir);
v=wspeed.*cosd(wdir);
g=gravity(80,alti); 
Z=g./9.81.*alti; 


q=hywex(temp_K,press,rh./100).*1000; % spec. humidity from Hyland and Wexler

 alti_c=alti+[diff(alti)./2; NaN];
 if size(u,2)==size(alti,1)
     u=u';
     v=v';
 end
 
grad_u=[diff(u)./diff(alti);NaN];
grad_v=[diff(v)./diff(alti);NaN];

u_c=u+[diff(u)./2;NaN];
v_c=v+[diff(v)./2;NaN];
press_c=press+[diff(press)./2;NaN];

% Richardson Number richtig aka Markus et al 2017
vaporpressure=vpress(temp_K,press,rh./100); % hPa
Rd=287;
Rw=461;
cp=1.006*1000;
theta_v=temp_K./(1-vaporpressure.*100.*(1-(Rd/Rw))./(press.*100)).*(1000./press).^(Rd/cp);
theta_v_c=theta_v+[diff(theta_v)./2;NaN];

Ri=g./theta_v_c(1).*(theta_v_c-theta_v_c(1)).*alti_c./(u_c.^2+v_c.^2);
q=hywex(temp_K,press,rh./100).*1000;
if sum(isnan(Ri))<length(Ri)
ABL_Pascal(kk,1)=alti_c(min(find(Ri>0.25)));
ABL_Pascal(kk,2)=press_c(min(find(Ri>0.25)));
else
    ABL_Pascal(kk,:)=NaN;
end

%% in case geopot h:
%  gridgpm=0:10:1e4;
% % 
% q2=interp1(Z,q,gridgpm);
% temp2=interp1(Z,temp,gridgpm);
% u2=interp1(Z,u,gridgpm);
% v2=interp1(Z,v,gridgpm);
% wdir2=winddir(u2,v2); % own routine
% wspeed2=sqrt(u2.^2+v2.^2);

%% in case pressure:
gridgpm=1020:-2:8;
Z=press;
q2=interp1(Z,q,gridgpm);
temp2=interp1(Z,temp,gridgpm);
u2=interp1(Z,u,gridgpm);
v2=interp1(Z,v,gridgpm);
wdir2=winddir(u2,v2); % own routine
wspeed2=sqrt(u2.^2+v2.^2);
%%
%nun in matrizen schreiben
mat_q(kk,:)=q2;
mat_temp(kk,:)=temp2;
mat_wspeed(kk,:)=wspeed2;
mat_wdir(kk,:)=wdir2;
%% only for humidity inversions!
 %temp2=q2;
 %mat_temp(kk,:)=q2;
%%
%    Calculating temperature inversion
        INV_COUNT_T=zeros(size(temp2));
        BB_T=zeros(size(temp2));
        INV_width=zeros(size(temp2));
        INV_intensity=zeros(size(temp2));
        
            [N_INV_tmp,Vtmp_tmp,W_INV_tmp,INV_INT_tmp,SBI_flag_tmp,BASE_tmp,TOP_tmp] = countinv_best(mat_temp(kk,:),gridgpm(end:-1:1),0.3/5);
            N_INV_test(kk,:)=N_INV_tmp; % indexing all inversion segments
            Vtmp_test(kk,:)=Vtmp_tmp; % background profile
            W_INV_test(kk,:)=W_INV_tmp; % gives inversion width at the index of inversion top
            INV_INT_test(kk,:)=INV_INT_tmp; % INT=width*delT inside inversion
            SBI_flag_test(kk,:)=SBI_flag_tmp; % an index of 1 indicates a surface based inversion
            BASE_TEST(kk,:)=BASE_tmp; % shows index value 1 at inversion base
            TOP_TEST(kk,:)=TOP_tmp; % shows index value 1 at inversion top
            dummy=find(TOP_TEST(kk,:)==1);
            if ~isempty(dummy)
          altidummy=gridgpm(find(TOP_TEST(kk,:)==1));
          altidummy2=gridgpm(find(BASE_TEST(kk,:)==1));

      for loopi=1:length(dummy)
         nowalti=altidummy(loopi);
         nowalti2=altidummy2(loopi);

         TOP_press{kk,loopi}=press(find(abs(alti-nowalti)==min(abs(alti-nowalti))));
         BASE_press{kk,loopi}=press(find(abs(alti-nowalti2)==min(abs(alti-nowalti2))));
if press(find(abs(alti-nowalti)==min(abs(alti-nowalti))))==press(find(abs(alti-nowalti2)==min(abs(alti-nowalti2))))
         TOP_press{kk,loopi}=press(find(abs(alti-nowalti)==min(abs(alti-nowalti)))+1);

end
      end
      
            end
            
 %% Estimating inversion base and top of the second lowest inversions
INV_delT_test=INV_INT_test./W_INV_test;
INV_H_test=W_INV_test>0;
clear H_topINV1, clear H_topINV2, clear T_topINV1, clear T_topINV2

    tmp=(gridgpm(TOP_TEST(kk,:)==1));
    idtmp=temp2(TOP_TEST(kk,:)==1);
    if isempty(tmp)
        H_topINV1(kk)=NaN;
        T_topINV1(kk)=NaN;
        H_topINV2(kk)=NaN;
        T_topINV2(kk)=NaN;
    elseif ~isempty(tmp)
        H_topINV1(kk)=tmp(1);
        T_topINV1(kk)=idtmp(1);
        if size(tmp,1)>1
            H_topINV2(kk)=tmp(2);
            T_topINV2(kk)=idtmp(2);
        else
            H_topINV2(kk)=NaN;
            T_topINV2(kk)=NaN;
        end
    end

clear H_baseINV1, clear H_baseINV2, clear T_baseINV1, clear T_baseINV2
for i=1:size(temp2)
    tmp=(gridgpm(BASE_TEST(:,i)==1));
    idtmp=temp2(BASE_TEST(:,i)==1);
    if isempty(tmp)
        H_baseINV1(i)=NaN;
        T_baseINV1(i)=NaN;
        H_baseINV2(i)=NaN;
        T_baseINV2(i)=NaN;
    elseif ~isempty(tmp)
        H_baseINV1(i)=tmp(1);
        T_baseINV1(i)=idtmp(1);
        if size(tmp,1)>1
            H_baseINV2(i)=tmp(2);
            T_baseINV2(i)=idtmp(2);
        else
            H_baseINV2(i)=NaN;
            T_baseINV2(i)=NaN;
        end
    end
end
 % plotting for test purposes!
%   kk=156;
%   Vplot=mat_temp(kk,:);
%   Hplot=gridgpm;
  %Vplot(find(Hplot==MaxHeight(kk))+1:end)=NaN;
  %Hplot(find(Hplot==MaxHeight(kk))+1:end)=NaN;
%  figure()
%  hold on
%     plot(Vplot,Hplot,'k-')
%     plot(Vplot(BASE_TEST(kk,:)==1),Hplot(BASE_TEST(kk,:)==1),'bsq')
%     plot(Vplot(TOP_TEST(kk,:)==1),Hplot(TOP_TEST(kk,:)==1),'ro')
    %axis ij
end

save('ABL_Pascal.mat','ABL_Pascal')
modified=0;
plotoly = 1;
    case 1
        %%
        close all
        figure
        orient landscape
      if modified == 0
          % 2. Juni hat keine Mitternachts-sondierung. Den punkt virtuell
          % erzeugen:
          soundingdate=[soundingdate(1:17) soundingdate(17)+0.25 soundingdate(18:end)];
       
SBI_flag_test=[SBI_flag_test(1:17,:)' SBI_flag_test(17,:)'.*NaN SBI_flag_test(18:end,:)']';
TOP_TEST=[TOP_TEST(1:17,:)' TOP_TEST(17,:)'.*NaN TOP_TEST(18:end,:)']';
BASE_TEST=[BASE_TEST(1:17,:)' BASE_TEST(17,:)'.*NaN BASE_TEST(18:end,:)']';
          
%          case pressure:
         mat_q=cat(1,mat_q(1:17,:),NaN.*ones(1,507),mat_q(18:end,:));
         mat_temp=cat(1,mat_temp(1:17,:),NaN.*ones(1,507),mat_temp(18:end,:));
         mat_wdir=cat(1,mat_wdir(1:17,:),NaN.*ones(1,507),mat_wdir(18:end,:));
         mat_speed=cat(1,mat_wspeed(1:17,:),NaN.*ones(1,507),mat_wspeed(18:end,:));

% case height:
%          mat_q=cat(1,mat_q(1:17,:),NaN.*ones(1,1001),mat_q(18:end,:));
%          mat_temp=cat(1,mat_temp(1:17,:),NaN.*ones(1,1001),mat_temp(18:end,:));
%          mat_wdir=cat(1,mat_wdir(1:17,:),NaN.*ones(1,1001),mat_wdir(18:end,:));
%          mat_speed=cat(1,mat_wspeed(1:17,:),NaN.*ones(1,1001),mat_wspeed(18:end,:));
         
         % interpolate humidity for plotting purposes only
        
      end
      xnew=datenum(2017,5,27,12,0,0):0.5:datenum(2017,6,19,12,0,0);
      
       % ynew=0:100:1e4; % case height
       ynew=1020:-10:8; % case pressure
      
       [xnew2 ynew2]=meshgrid(xnew,ynew);
        qnew=interp2(soundingdate,gridgpm(1:end),mat_q(:,1:end)',xnew2,ynew2);
      plotx=soundingdate+[diff(soundingdate./2) 0.125];
      
      
      modified=1;     
end

load('ABL_Pascal.mat');
ABL_Pascal=[ABL_Pascal(1:17,:)' ABL_Pascal(17,:)'.*NaN ABL_Pascal(18:end,:)']';


%% plot Pascal temperatures and humidity separeately

        xdate2=NaN.*(datenum(2017,5,2,12,0,0):1:datenum(2017,6,31,12,0,0));
        xdate3=(datenum(2017,5,2,12,0,0):1:datenum(2017,6,31,12,0,0));
        xdate2(1:7:end)=xdate(1:1:end);
        for kk=1:length(xdate2)
            if isnan(xdate2(kk))
                xdate_cell{kk}=[];
            else
                            xdate_cell{kk}=datestr(xdate2(kk),'dd/mm');

            end
        end      
close all
      figure
      
      
  pp=pcolor((soundingdate-11/24),gridgpm./1,mat_temp');
      set(pp,'edgecolor','none');
      caxis([-45 10])
 set(gca,'xtick',xdate3,'tickdir','out','xticklabel',xdate_cell,'ylim',[300 1020],'xlim',[datenum(2017,5,23,0,0,0) datenum(2017,6,27,0,0,0)+0.5],'fontsize',16);

           hold on
           plot(plotx-11/24,ABL_Pascal(:,2),'o','markersize',4)

        for yind=[61 111 161 211 261 311]

            for xind=plotx([3 4:4:end-1])
                windbarb(plotx(find(plotx==xind))-11/24,gridgpm(yind)/1,mat_wspeed(find(plotx==xind),yind),mat_wdir(find(plotx==xind),yind),0.04,0.7,'black')
            end
        end
plot([xnew(21) xnew(21)], [300 1030],'color',[150 150 150]./255,'linewidth',2,'linestyle','--')  
plot([xnew(42) xnew(42)], [300 1030],'color',[150 150 150]./255,'linewidth',2,'linestyle','--')  
jbfill(xnew(1:4)-0.6,1019.*ones(1,4),301.*ones(1,4),'white','none',0,0) % EDIT 19.12.17 Erlend will nur die Periode 6 - 16 (ice locked)


 % colormap(brewermap(22,'YlOrRd'))
  
  colormap(brewermap(22,'*Spectral'))

 %       ylabel(cc,'temperature [^oC]')
        

                ylabel('pressure [hPa]');

axis ij 
box on
plot([datenum(2017,5,23,0,0,0) datenum(2017,6,27,0,0,0)],[300 300],'black')

 
 windbarb(xdate3(end-11)-0.5,950, 1,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,950,'<2 m s^{-1}')
windbarb(xdate3(end-11)-0.5,900, 2,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,900,'2 m s^{-1}')
windbarb(xdate3(end-11)-0.5,850,4,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,850,'4 m s^{-1}')
windbarb(xdate3(end-11)-0.5,800,6,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,800,'6 m s^{-1}')
windbarb(xdate3(end-11)-0.5,750,8,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,750,'8 m s^{-1}')
windbarb(xdate3(end-11)-0.5,700,10,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,700,'10 m s^{-1}')
windbarb(xdate3(end-11)-0.5,650,12,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,650,'12 m s^{-1}')
windbarb(xdate3(end-11)-0.5,600,14,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,600,'14 m s^{-1}')
windbarb(xdate3(end-11)-0.5,550,16,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,550,'16 m s^{-1}')
windbarb(xdate3(end-11)-0.5,500,18,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,500,'18 m s^{-1}')
windbarb(xdate3(end-11)-0.5,450,20,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,450,'20 m s^{-1}')

plot(xdate3(end-10)-0.1-0.5,360,'o','markeredgecolor','blue')
text(xdate3(end-9)+0.3-0.5,355,{'ABL';'height'})

 set(findall(gcf,'-property','FontSize'),'FontSize',16)

set(gcf,'renderer','painters')
print -depsc PS_only_Temp_V2

%% now humidity

close all
      figure
      
  pp=pcolor((soundingdate-11/24),gridgpm./1,mat_q');
      set(pp,'edgecolor','none');
      caxis([0 6])
 set(gca,'xtick',xdate3,'tickdir','out','xticklabel',xdate_cell,'ylim',[300 1020],'xlim',[datenum(2017,5,23,0,0,0) datenum(2017,6,27,0,0,0)+0.5],'fontsize',16);

           hold on
                      plot(plotx-11/24,ABL_Pascal(:,2),'o','markersize',4)

          for yind=[61 111 161 211 261 311]

            for xind=plotx([3 4:4:end-1])
                windbarb(plotx(find(plotx==xind))-11/24,gridgpm(yind)/1,mat_wspeed(find(plotx==xind),yind),mat_wdir(find(plotx==xind),yind),0.04,0.7,'black')
            end
        end
    
plot([xnew(21) xnew(21)], [300 1020],'color',[150 150 150]./255,'linewidth',2,'linestyle','--')  
plot([xnew(42) xnew(42)], [300 1020],'color',[150 150 150]./255,'linewidth',2,'linestyle','--')  
jbfill(xnew(1:4)-0.6,1019.*ones(1,4),301.*ones(1,4),'white','none',0,0) % EDIT 19.12.17 Erlend will nur die Periode 6 - 16 (ice locked)


    colormap(brewermap(12,'*Spectral'))

        %ylabel(cc,'humidity [g/kg]')
        

                ylabel('pressure [hPa]');

axis ij 
box on
plot([datenum(2017,5,23,0,0,0) datenum(2017,6,27,0,0,0)],[300 300],'black')

 windbarb(xdate3(end-11)-0.5,950, 1,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,950,'<2 m s^{-1}')
windbarb(xdate3(end-11)-0.5,900, 2,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,900,'2 m s^{-1}')
windbarb(xdate3(end-11)-0.5,850,4,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,850,'4 m s^{-1}')
windbarb(xdate3(end-11)-0.5,800,6,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,800,'6 m s^{-1}')
windbarb(xdate3(end-11)-0.5,750,8,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,750,'8 m s^{-1}')
windbarb(xdate3(end-11)-0.5,700,10,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,700,'10 m s^{-1}')
windbarb(xdate3(end-11)-0.5,650,12,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,650,'12 m s^{-1}')
windbarb(xdate3(end-11)-0.5,600,14,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,600,'14 m s^{-1}')
windbarb(xdate3(end-11)-0.5,550,16,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,550,'16 m s^{-1}')
windbarb(xdate3(end-11)-0.5,500,18,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,500,'18 m s^{-1}')
windbarb(xdate3(end-11)-0.5,450,20,90,0.04,0.7,'black')
text(xdate3(end-9)+0.4-0.5,450,'20 m s^{-1}')

plot(xdate3(end-10)-0.1-0.5,360,'o','markeredgecolor','blue')
text(xdate3(end-9)+0.3-0.5,355,{'ABL';'height'})

 set(findall(gcf,'-property','FontSize'),'FontSize',16)
set(gcf,'renderer','painters')
 set(findall(gcf,'-property','FontSize'),'FontSize',16)

print -depsc PS_only_Hum_V2

%%
%ABL_Pascal=ABL_Pascal'; 
xnew=datenum(2017,5,27,12,0,0):0.5:datenum(2017,6,19,12,0,0);
      xdate=datenum(2017,5,2,12,0,0):7:datenum(2017,6,31,12,0,0);
close all
figure
set(gcf,'renderer','painters')
     mat_temp(1,:)=NaN;
       plot([-100 -100],[-99 -98],'linewidth',2,'color',[255,20,147]./255);
        hold on
        plot([-100 -100],[-99 -98],'linewidth',2,'color',[160 82 45]./255);
        plot(soundingdate(1:84),ABL_Pascal(1:84,1),'black','linewidth',2) %edit: keine
 pp=pcolor((soundingdate-[diff(soundingdate)./2 NaN]),gridgpm./1,mat_temp');
 set(pp,'edgecolor','none');
 caxis([0 6])
 %caxis([-14 12])
 colormap(brewermap(12,'*Spectral'))

 hold on
for kk=1:84
    if kk==1
      
      
       

        set(gca,'xlim',[datenum(2017,5,23,0,0,0) datenum(2017,6,27,0,0,0)+0.5])
    end
   dummy=(find(SBI_flag_test(kk,:)==1));
   if ~isempty(dummy)
      plot([soundingdate(kk) soundingdate(kk)], [gridgpm(min(find(~isnan(mat_temp(kk,:))))) gridgpm(dummy)],'linewidth',2,'color',[255,20,147]./255)

   else
       dummy=(find(TOP_TEST(kk,:)==1));
       dummy2=(find(BASE_TEST(kk,:)==1));
       
       if ~isempty(dummy)
           upper=gridgpm(dummy(1));
           lower=gridgpm(dummy2(1));
   plot([soundingdate(kk) soundingdate(kk)], [lower upper],'linewidth',2,'color',[160 82 45]./255)
   
       end
   end
   hold on
end
plot(soundingdate(1:83),ABL_Pascal(1:83,1),'black','linewidth',2)
     set(gca,'xtick',xdate3,'tickdir','out','xticklabel',xdate_cell,'ylim',[0 2000],'xlim',[datenum(2017,5,28,0,0,0) datenum(2017,6,19,0,0,0)+0.1],'fontsize',16);
 ylabel('height [m]')
 plot([xnew(21) xnew(21)], [0 2000],'color',[150 150 150]./255,'linewidth',2,'linestyle','--')  
plot([xnew(42) xnew(42)], [0 2000],'color',[150 150 150]./255,'linewidth',2,'linestyle','--')  
cc=colorbar;
%ylabel(cc,'temperature [^oC]')
ylabel(cc,'humidity [g/kg]') 
set(findall(gcf,'-property','FontSize'),'FontSize',16);


    % print -depsc q_inv
 
