

brexit
load('ErlendV2.mat'); % NyAlesund sondes
load('fig7_V2.mat')% Pascal data

%% P1 [May 22 - 29] - Ny A only, and exclude May 22.

soundingdate_Nya=mat_time(:,20); 
cutleft = datenum(2017,5,23,0,0,0);
cutright = datenum(2017,5,30,0,0,0); 

ind_Nya=find((soundingdate_Nya<cutright)&(soundingdate_Nya>cutleft)); 

% q
dummy_q=squeeze(mat_q(ind_Nya,:));
Nya_mean_hum=mynanmean(dummy_q,1); 

Nya_max_hum=nanmax(dummy_q);
Nya_min_hum=nanmin(dummy_q);

%t
dummy_temp=squeeze(mat_temp(ind_Nya,:));
Nya_mean_temp=mynanmean(dummy_temp,1); 

Nya_max_temp=nanmax(dummy_temp);
Nya_min_temp=nanmin(dummy_temp);


%% plot a
close all
figure



lolo=jbfill((gridgpm(2:end)),Nya_max_temp(2:end),Nya_min_temp(2:end),[0 0 1],'none',0,0.4);
patch2 = findobj(lolo,'type','Patch'); % The child object of axes is a Patch Object
set(patch2,'FaceAlpha',0.5);
hold on

plot(gridgpm,Nya_mean_temp,'color',[0 191 255]./255,'linewidth',2,'linestyle','-')
legend('NYA May 23 - May 29','location','southwest');grid on

view([-270 90]);
set(gca,'ylim',[-70 10],'xlim',[500 1020],'FontSize',16)
xlabel('pressure [hPa]')
ylabel('temperature [^oC]')
print -depsc Fig_7a
print -dpng Fig_7a

%% b
close all
lolo=jbfill((gridgpm(2:end)),Nya_max_hum(2:end),Nya_min_hum(2:end),[0 0 1],'none',0,0.4);
patch2 = findobj(lolo,'type','Patch'); % The child object of axes is a Patch Object
set(patch2,'FaceAlpha',0.5);
hold on

plot(gridgpm,Nya_mean_hum,'color',[0 191 255]./255,'linewidth',2,'linestyle','-')


legend('NYA May 23 - May 29','location','Northeast');grid on

view([-270 90]);
set(gca,'ylim',[0 5.5],'xlim',[500 1020],'FontSize',16)
xlabel('pressure [hPa]')
ylabel('spec. humidity [g/kg]')
print -depsc Fig_7b
print -dpng Fig_7b



%% P2 [May 30 - June 12] - Ny A only., and exclude May 22.

soundingdate_Nya=mat_time(:,20); 
cutleft = datenum(2017,5,30,0,0,0);
cutright = datenum(2017,6,13,0,0,0); 

ind_Nya=find((soundingdate_Nya<cutright)&(soundingdate_Nya>cutleft)); % funktioniert

% q
dummy_q=squeeze(mat_q(ind_Nya,:));
Nya_mean_hum=mynanmean(dummy_q,1); % mean profile P1
% now calculate min and max
Nya_max_hum=nanmax(dummy_q);
Nya_min_hum=nanmin(dummy_q);

%t
dummy_temp=squeeze(mat_temp(ind_Nya,:));
Nya_mean_temp=mynanmean(dummy_temp,1); % mean profile P1
% now calculate min and max
Nya_max_temp=nanmax(dummy_temp);
Nya_min_temp=nanmin(dummy_temp);

cutleft = datenum(2017,6,6,0,0,0); 
cutright = datenum(2017,6,13,0,0,0); 
ind_Pascal=find((soundingdate<cutright)&(soundingdate>cutleft)); 

% q
dummy_q_Pascal=squeeze(mat_q_Pascal(ind_Pascal,:));
Pascal_mean_hum=mynanmean(dummy_q_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_hum=nanmax(dummy_q_Pascal);
Pascal_min_hum=nanmin(dummy_q_Pascal);

%t
dummy_temp_Pascal=squeeze(mat_temp_Pascal(ind_Pascal,:));
Pascal_mean_temp=mynanmean(dummy_temp_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_temp=nanmax(dummy_temp_Pascal);
Pascal_min_temp=nanmin(dummy_temp_Pascal);

% edit: same Pascal Plots for Polarsterns Ocean periods

cutleft = datenum(2017,5,29,0,0,0); 
cutright = datenum(2017,6,6,0,0,0); 
ind_Pascal=find((soundingdate<cutright)&(soundingdate>cutleft)); 
% q
dummy_q_Pascal=squeeze(mat_q_Pascal(ind_Pascal,:));
Pascal_mean_hum2=mynanmean(dummy_q_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_hum2=nanmax(dummy_q_Pascal);
Pascal_min_hum2=nanmin(dummy_q_Pascal);

%t
dummy_temp_Pascal=squeeze(mat_temp_Pascal(ind_Pascal,:));
Pascal_mean_temp2=mynanmean(dummy_temp_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_temp2=nanmax(dummy_temp_Pascal);
Pascal_min_temp2=nanmin(dummy_temp_Pascal);

%% c


close all
figure


lolo=jbfill((gridgpm(2:end)),Nya_max_temp(2:end),Nya_min_temp(2:end),[0 0 1],'none',0,0.4);
patch2 = findobj(lolo,'type','Patch'); % The child object of axes is a Patch Object
set(patch2,'FaceAlpha',0.5);
hold on


lulu=jbfill((gridgpm(2:end)),Pascal_max_temp(2:end),Pascal_min_temp(2:end),[1 0 0],'none',0,0.4);
patch1 = findobj(lulu,'type','Patch'); % The child object of axes is a Patch Object
set(patch1,'FaceAlpha',0.5);
hold on


lulu2=jbfill((gridgpm(~isnan(Pascal_max_hum2)))-1000,Pascal_max_hum2(~isnan(Pascal_max_hum2)),Pascal_min_hum2(~isnan(Pascal_max_hum2)),[.6 .6 .6],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);

lulu2=jbfill((gridgpm(3:end)),Pascal_max_temp2(3:end),Pascal_min_temp2(3:end),[0 0 0],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);
hold on

plot(gridgpm,Pascal_mean_temp2,'color',[.6 .6 .6],'linewidth',2,'linestyle','-')
plot(gridgpm,Pascal_mean_temp,'red','linewidth',2,'linestyle','-')
plot(gridgpm,Nya_mean_temp,'color',[0 191 255]./255,'linewidth',2,'linestyle','-')
legend('NYA May 30 - June 12','PSi June 6 - June 12','PSo May 30 - June 5','location','southwest')

grid on

view([-270 90]);
set(gca,'ylim',[-70 10],'xlim',[500 1020],'FontSize',16)
xlabel('pressure [hPa]')
ylabel('temperature [^oC]')
%title('c')
print -depsc Fig_7c
print -dpng Fig_7c

%% d


close all
figure



lolo=jbfill((gridgpm(2:end)),Nya_max_hum(2:end),Nya_min_hum(2:end),[0 0 1],'none',0,0.4);
patch2 = findobj(lolo,'type','Patch'); % The child object of axes is a Patch Object
set(patch2,'FaceAlpha',0.5);
hold on


lulu=jbfill((gridgpm(2:end)),Pascal_max_hum(2:end),Pascal_min_hum(2:end),[1 0 0],'none',0,0.4);
patch1 = findobj(lulu,'type','Patch'); % The child object of axes is a Patch Object
set(patch1,'FaceAlpha',0.5);


lulu2=jbfill((gridgpm(~isnan(Pascal_max_hum2)))-1000,Pascal_max_hum2(~isnan(Pascal_max_hum2)),Pascal_min_hum2(~isnan(Pascal_max_hum2)),[.6 .6 .6],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);

lulu2=jbfill((gridgpm(3:end)),Pascal_max_hum2(3:end),Pascal_min_hum2(3:end),[0 0 0],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);

hold on

plot(gridgpm,Pascal_mean_hum2,'color',[.6 .6 .6],'linewidth',2,'linestyle','-')
plot(gridgpm,Pascal_mean_hum,'red','linewidth',2,'linestyle','-')
plot(gridgpm,Nya_mean_hum,'color',[0 191 255]./255,'linewidth',2,'linestyle','-')

grid on

legend('NYA May 30 - June 12','PSi June 6 - June 12','PSo May 30 - June 5','location','northeast')

view([-270 90]);
set(gca,'ylim',[0 5.5],'xlim',[500 1020],'FontSize',16)
xlabel('pressure [hPa]')
ylabel('spec. humidity [g/kg]')
print -depsc Fig_7d
print -dpng Fig_7d

%% P3 [June 13 - June 26] 

soundingdate_Nya=mat_time(:,20); 
cutleft = datenum(2017,6,13,0,0,0);
cutright = datenum(2017,6,27,0,0,0); 

ind_Nya=find((soundingdate_Nya<cutright)&(soundingdate_Nya>cutleft)); 

% q
dummy_q=squeeze(mat_q(ind_Nya,:));
Nya_mean_hum=mynanmean(dummy_q,1); % mean profile P1
% now calculate min and max
Nya_max_hum=nanmax(dummy_q);
Nya_min_hum=nanmin(dummy_q);

%t
dummy_temp=squeeze(mat_temp(ind_Nya,:));
Nya_mean_temp=mynanmean(dummy_temp,1); % mean profile P1
% now calculate min and max
Nya_max_temp=nanmax(dummy_temp);
Nya_min_temp=nanmin(dummy_temp);


cutleft = datenum(2017,6,13,0,0,0);
cutright = datenum(2017,6,17,0,0,0); 
ind_Pascal=find((soundingdate<cutright)&(soundingdate>cutleft)); 

% q
dummy_q_Pascal=squeeze(mat_q_Pascal(ind_Pascal,:));
Pascal_mean_hum=mynanmean(dummy_q_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_hum=nanmax(dummy_q_Pascal);
Pascal_min_hum=nanmin(dummy_q_Pascal);

%t
dummy_temp_Pascal=squeeze(mat_temp_Pascal(ind_Pascal,:));
Pascal_mean_temp=mynanmean(dummy_temp_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_temp=nanmax(dummy_temp_Pascal);
Pascal_min_temp=nanmin(dummy_temp_Pascal);


cutleft = datenum(2017,6,16,0,0,0); 
cutright = datenum(2017,6,27,0,0,0); 
cutright = datenum(2017,6,19,0,0,0); 

ind_Pascal=find((soundingdate<cutright)&(soundingdate>cutleft));
% q
dummy_q_Pascal=squeeze(mat_q_Pascal(ind_Pascal,:));
Pascal_mean_hum2=mynanmean(dummy_q_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_hum2=nanmax(dummy_q_Pascal);
Pascal_min_hum2=nanmin(dummy_q_Pascal);

%t
dummy_temp_Pascal=squeeze(mat_temp_Pascal(ind_Pascal,:));
Pascal_mean_temp2=mynanmean(dummy_temp_Pascal,1); % mean profile P1
% now calculate min and max
Pascal_max_temp2=nanmax(dummy_temp_Pascal);
Pascal_min_temp2=nanmin(dummy_temp_Pascal);


%% e


close all
figure


lolo=jbfill((gridgpm(~isnan(Nya_max_temp))),Nya_max_temp(~isnan(Nya_max_temp)),Nya_min_temp(~isnan(Nya_max_temp)),[0 0 1],'none',0,0.4);
patch2 = findobj(lolo,'type','Patch'); % The child object of axes is a Patch Object
set(patch2,'FaceAlpha',0.5);
hold on

grid on
lulu=jbfill((gridgpm(~isnan(Pascal_max_temp))),Pascal_max_temp(~isnan(Pascal_max_temp)),Pascal_min_temp(~isnan(Pascal_max_temp)),[1 0 0],'none',0,0.4);
patch1 = findobj(lulu,'type','Patch'); % The child object of axes is a Patch Object
set(patch1,'FaceAlpha',0.5);
hold on

%Einschub: wegen der Legende
lulu2=jbfill((gridgpm(~isnan(Pascal_max_hum2)))-1000,Pascal_max_hum2(~isnan(Pascal_max_hum2)),Pascal_min_hum2(~isnan(Pascal_max_hum2)),[.6 .6 .6],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);

lulu2=jbfill((gridgpm(~isnan(Pascal_max_temp2))),Pascal_max_temp2(~isnan(Pascal_max_temp2)),Pascal_min_temp2(~isnan(Pascal_max_temp2)),[0 0 0],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);

plot(gridgpm,Pascal_mean_temp,'red','linewidth',2,'linestyle','-')
plot(gridgpm(6:end),Nya_mean_temp(6:end),'color',[0 191 255]./255,'linewidth',2,'linestyle','-')
plot(gridgpm,Pascal_mean_temp2,'color',[.6 .6 .6],'linewidth',2,'linestyle','-')


legend('NYA June 13 - June 26','PSi June 13 - June 16','PSo June 17 - June 18','location','southwest')

view([-270 90]);
set(gca,'ylim',[-70 10],'xlim',[500 1020],'FontSize',16)
xlabel('pressure [hPa]')
ylabel('temperature [^oC]')
%title('e')
print -depsc Fig_7e2
print -dpng Fig_7e2

%% f


close all
figure


lolo=jbfill((gridgpm(~isnan(Nya_max_hum))),Nya_max_hum(~isnan(Nya_max_hum)),Nya_min_hum(~isnan(Nya_max_hum)),[0 0 1],'none',0,0.4);
patch2 = findobj(lolo,'type','Patch'); % The child object of axes is a Patch Object
set(patch2,'FaceAlpha',0.5);
hold on



lulu=jbfill((gridgpm(~isnan(Pascal_max_hum))),Pascal_max_hum(~isnan(Pascal_max_hum)),Pascal_min_hum(~isnan(Pascal_max_hum)),[1 0 0],'none',0,0.4);
patch1 = findobj(lulu,'type','Patch'); % The child object of axes is a Patch Object
set(patch1,'FaceAlpha',0.5);
hold on

%Einschub: wegen der Legende
lulu2=jbfill((gridgpm(~isnan(Pascal_max_hum2)))-1000,Pascal_max_hum2(~isnan(Pascal_max_hum2)),Pascal_min_hum2(~isnan(Pascal_max_hum2)),[.6 .6 .6],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);

lulu2=jbfill((gridgpm(~isnan(Pascal_max_hum2))),Pascal_max_hum2(~isnan(Pascal_max_hum2)),Pascal_min_hum2(~isnan(Pascal_max_hum2)),[0 0 0],'none',0,0.4);
patch3 = findobj(lulu2,'type','Patch'); % The child object of axes is a Patch Object
set(patch3,'FaceAlpha',0.5);
hold on

grid on
plot(gridgpm,Pascal_mean_hum2,'color',[.6 .6 .6],'linewidth',2,'linestyle','-')
plot(gridgpm,Pascal_mean_hum,'red','linewidth',2,'linestyle','-')
plot(gridgpm,Nya_mean_hum,'color',[0 191 255]./255,'linewidth',2,'linestyle','-')

legend('NYA June 13 - June 26','PSi June 13 - June 16','PSo June 17 - June 18','location','northeast')




view([-270 90]);
set(gca,'ylim',[0 5.5],'xlim',[500 1020],'FontSize',16)
xlabel('pressure [hPa]')
ylabel('spec. humidity [g/kg]')
%title('f')
print -depsc Fig_7f2
print -dpng Fig_7f2

